/*================================================================================================================================================*/
// ********************************************** THESE ARE THE INFORMATIONS OF THE MAP: ******************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

// THE BUFFALO LAKE:
// CREATED BY DANY:
// AUGUST 2008:

/*================================================================================================================================================*/
// *********************************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT ******************************************************* //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.01);
/*================================================================================================================================================*/
// ************************************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	

        if (rmAllocateSubCivs(6) == true)
    {
		subCiv0=rmGetCivID("Comanche");
		rmEchoInfo("subCiv0 is Comanche "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "Comanche");

		subCiv1=rmGetCivID("Cheyenne");
		rmEchoInfo("subCiv1 is Cheyenne "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "Cheyenne");

		subCiv2=rmGetCivID("Cheyenne");
		rmEchoInfo("subCiv2 is Cheyenne "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "Cheyenne");
		
		subCiv3=rmGetCivID("Comanche");
		rmEchoInfo("subCiv3 is Comanche "+subCiv3);
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "Comanche");
		
		subCiv4=rmGetCivID("Comanche");
		rmEchoInfo("subCiv4 is Comanche "+subCiv4);
		if (subCiv4 >= 0)
		rmSetSubCiv(4, "Comanche");
		
		subCiv5=rmGetCivID("Cheyenne");
		rmEchoInfo("subCiv5 is Cheyenne "+subCiv5);
		if (subCiv5 >= 0)
		rmSetSubCiv(5, "Cheyenne");
    }
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.05);
/*================================================================================================================================================*/
// ********************************************************** DEFINE THE MAP SIZE: ************************************************************** //	
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
   
        int playerTiles=30000;

	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(632, 632); // THE NUMBER 632 IS REPLACING THE WORD - "size" -:
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.10);
/*================================================================================================================================================*/
// ******************************************************* DEFINE THE MAP PARAMETERS: *********************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);

        // PICKS DEFAULT TERRAIN AND WATER:
	    rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	    
		// SET BASE TERRAIN MIX
		rmSetBaseTerrainMix("great plains drygrass");
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
	    
		// SET LIGHTING:
		rmSetLightingSet("great plains");
	    
		// SET MAP TYPE
		rmSetMapType("greatPlains");
	    rmSetMapType("land");
	    rmSetMapType("grass");
		
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.15);
/*================================================================================================================================================*/
// ****************************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: **************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.20);
/*================================================================================================================================================*/
// ********************************************************** DEFINE THE CONSTRAINTS: *********************************************************** //
// ***************************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ***************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
    
	// MAP EDGE CONSTRAINTS:
    // int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));

	
    // PLAYER CONSTRAINTS:
    int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 8.0);
	
	// CARDINAL DIRECTIONS:
	int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
    
	// CREATE SOME WATER CONSTRAINTS:
	int avoidWater3 = rmCreateTerrainDistanceConstraint("stuff vs.water 3", "Land", false, 3.0);
	int avoidWater5 = rmCreateTerrainDistanceConstraint("stuff vs.water 5", "Land", false, 5.0);
	int avoidWater6 = rmCreateTerrainDistanceConstraint("stuff vs.water 6", "Land", false, 6.0);
	int avoidWater8 = rmCreateTerrainDistanceConstraint("stuff vs.water 8", "Land", false, 8.0);
	int avoidWater10 = rmCreateTerrainDistanceConstraint("stuff vs. water 10", "Land", false, 10.0);
	int avoidWater12 = rmCreateTerrainDistanceConstraint("stuff vs. water 12", "Land", false, 12.0);
	int avoidWater15 = rmCreateTerrainDistanceConstraint("stuff vs. water 15", "Land", false, 15.0);
    int avoidWater20 = rmCreateTerrainDistanceConstraint("stuff vs. water 20", "Land", false, 20.0);
	int avoidWater25 = rmCreateTerrainDistanceConstraint("stuff vs. water 25", "Land", false, 25.0);
	int avoidWater30 = rmCreateTerrainDistanceConstraint("stuff vs. water 30", "Land", false, 30.0);
	int avoidWater35 = rmCreateTerrainDistanceConstraint("stuff vs. water 35", "Land", false, 35.0);
	
	// CIRCLE CONSTRAINT:
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.25);
/*================================================================================================================================================*/
// **************************************************** DEFINE AND PLACE THE TRADE ROUTE: ******************************************************* //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
    
		// CREATE THE CLASS SOCKET:
		int classSocket = rmDefineClass("SocketClass");
		
	    // CREATE THE CLASS SOCKET CONSTRAINTS:
	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("SocketClass"), 8.0);
		
		// CREATE THE TRADE ROUTE CONSTRAINTS:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	    int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts North");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
		
		rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.60);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.90);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route");
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/  
	  
	    rmPlaceObjectDefAtLoc(socketID, 0, 0.10, 0.60); 
		rmPlaceObjectDefAtLoc(socketID, 0, 0.40, 0.90);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
      
	    // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	    int tradeRoute2ID = rmCreateTradeRoute();
        socketID=rmCreateObjectDef("sockets to dock Trade Posts South");
        rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);
		
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
        rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
	
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.90, 0.40);
	    rmAddTradeRouteWaypoint(tradeRoute2ID, 0.60, 0.10);
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

        placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/  

        rmPlaceObjectDefAtLoc(socketID, 0, 0.90, 0.40); 
		rmPlaceObjectDefAtLoc(socketID, 0, 0.60, 0.10); 
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.30);
/*================================================================================================================================================*/
// ************************************************** SET UP THE PLAYER STARTING LOCATIONS:	***************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		float teamStartLoc = rmRandFloat(0.0, 1.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// TEAM 0 STARTS ON TOP:
		
		if (teamStartLoc > 0.5) 

	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.650, 0.850, 0.850, 0.650, 0.0, 0.0);
		rmSetTeamSpacingModifier(0.20);
		
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.350, 0.150, 0.150, 0.350, 0.0, 0.0);
		rmSetTeamSpacingModifier(0.20);
		
	}
		else
	{
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.350, 0.150, 0.150, 0.350, 0.0, 0.0);
		rmSetTeamSpacingModifier(0.20);
		
		rmSetPlacementTeam(1);
		rmPlacePlayersLine(0.650, 0.850, 0.850, 0.650, 0.0, 0.0);
		rmSetTeamSpacingModifier(0.20);
	}
	
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.35);
/*================================================================================================================================================*/
// ********************************************************* SET UP THE PLAYER AREAS: *********************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		float playerFraction=rmAreaTilesToFraction(1750);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
	    for(i=1; <cNumberPlayers)
	{
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, avoidCliff); 
		//rmAddAreaConstraint(id, avoidWater5); 
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
		//rmSetAreaMix(id, "rockies_snow");
		//rmSetAreaMix(id, "texas_grass");
		//rmSetAreaMix(id, "mongolia_desert");

        // SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground1_tex");		
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
	
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, true);
	}
	    // BUILD THE AREAS:
	    rmBuildAllAreas();

/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.40);
/*================================================================================================================================================*/
// ************************************************* DEFINE SOME VARIABLES TO BE USED LATER: **************************************************** //   
/*================================================================================================================================================*/

	    int numTries = -1;
	    int failCount = -1;

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR
   rmSetStatusText("",0.425);
/*================================================================================================================================================*/
// **************************************************** DEFINE AND PLACE THE CENTER LAKE: ******************************************************* //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // CREATE THE CLASS LAKE:
		int classLake=rmDefineClass("lake");
		
		// CREATE THE CLASS LAKE CONSTRAINTS:
		int lakeConstraint=rmCreateClassDistanceConstraint("stuff avoid the center lake", classLake, 6.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int centerLakeID=rmCreateArea("The Center Lake");
		rmSetAreaWaterType(centerLakeID, "texas pond");
	    rmSetAreaSize(centerLakeID, 0.020, 0.020);
		rmSetAreaCoherence(centerLakeID, 1.00);
		rmSetAreaLocation(centerLakeID, 0.500, 0.500);
		
		//rmAddAreaInfluenceSegment(centerLakeID, 0.000, 0.000, 0.000, 0.000);

        rmAddAreaInfluenceSegment(centerLakeID, 0.350, 0.450, 0.350, 0.550); // = 01 02 :
		rmAddAreaInfluenceSegment(centerLakeID, 0.350, 0.550, 0.450, 0.650); // = 02 03 :
		rmAddAreaInfluenceSegment(centerLakeID, 0.450, 0.650, 0.550, 0.650); // = 03 04 :
		rmAddAreaInfluenceSegment(centerLakeID, 0.550, 0.650, 0.650, 0.550); // = 04 05 :
		rmAddAreaInfluenceSegment(centerLakeID, 0.650, 0.550, 0.650, 0.450); // = 05 06 :
		rmAddAreaInfluenceSegment(centerLakeID, 0.650, 0.450, 0.550, 0.350); // = 06 07 :
		
		rmAddAreaInfluenceSegment(centerLakeID, 0.550, 0.350, 0.450, 0.350); // = 07 08 :
		rmAddAreaInfluenceSegment(centerLakeID, 0.450, 0.350, 0.350, 0.450); // = 08 01 :
	
		rmAddAreaToClass(centerLakeID, classLake);
	    rmSetAreaBaseHeight(centerLakeID, 1.0);
	    rmSetAreaObeyWorldCircleConstraint(centerLakeID, false);
	    rmSetAreaMinBlobs(centerLakeID, 1);
	    rmSetAreaMaxBlobs(centerLakeID, 1);
	    rmSetAreaMinBlobDistance(centerLakeID, 1);
	    rmSetAreaMaxBlobDistance(centerLakeID, 1);
	    rmSetAreaSmoothDistance(centerLakeID, 0);
	    
		rmBuildArea(centerLakeID); 

/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.45);
/*================================================================================================================================================*/
// ***************************************** DEFINE THE TCID AND THE STARTING UNITS AND RESOURCES: ********************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    int avoidAll=rmCreateTypeDistanceConstraint("objects avoid all", "all", 6.0);

        int avoidPlayerBerries = rmCreateTypeDistanceConstraint("objects avoid player berries", "AbstractFruit", 8.0);
		
		int avoidPlayerNugget=rmCreateTypeDistanceConstraint("stuff avoid player nugget", "AbstractNugget", 10.0);
		int treeAvoidPlayerNugget=rmCreateTypeDistanceConstraint("tree avoid player nugget", "AbstractNugget", 15.0);
		
		int avoidTrees = rmCreateTypeDistanceConstraint("objects avoid trees", "TreeGreatPlains", 15.0);
		
		// FLAG CONSTRAINTS FOR HC SPAWN POINT:
        int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, 0, rmGetMapXSize()-15, 0, 0, 0);
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 18.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 22); 
 		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE TCID:
		int TCID = rmCreateObjectDef("player TC");
	    if ( rmGetNomadStart())
		rmAddObjectDefItem(TCID, "coveredWagon", 1, 0);
	    else
		rmAddObjectDefItem(TCID, "townCenter", 1, 0);

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0); 
	    //rmAddObjectDefConstraint(TCID, avoidWater8);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
    	
	    // DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(4.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 8.0);
	    //rmAddObjectDefConstraint(startingUnits, avoidAll);
	    
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE PLAYER GOLD:
	    int playerGoldID = rmCreateObjectDef("The Player Silver");
	    rmAddObjectDefItem(playerGoldID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(playerGoldID, 14.0);
	    rmSetObjectDefMaxDistance(playerGoldID, 20.0);
	    rmAddObjectDefConstraint(playerGoldID, avoidAll);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        //DEFINE THE PLAYER CRATE: - ( DOCK WAGON ) -
	    int playerCrateID=rmCreateObjectDef("The Player Crates");
		rmAddObjectDefItem(playerCrateID, "crateOfFood", rmRandInt(2, 3), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", rmRandInt(1, 2), 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 4.0);
	    rmSetObjectDefMinDistance(playerCrateID, 9.0);
	    rmSetObjectDefMaxDistance(playerCrateID, 12.0);
	    rmAddObjectDefConstraint(playerCrateID, avoidAll);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER BERRIES:
	    int playerBerriesID=rmCreateObjectDef("The Player Berries");
	    rmAddObjectDefItem(playerBerriesID, "berrybush", 7, 4.0);	
        rmSetObjectDefMinDistance(playerBerriesID, 13);
        rmSetObjectDefMaxDistance(playerBerriesID, 16);	
	    rmAddObjectDefConstraint(playerBerriesID, avoidAll);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		// DEFINE THE PLAYER POP BLOCK:
	    int playerPopBlock=rmCreateObjectDef("The Player Pop Block");
	    rmAddObjectDefItem(playerPopBlock, "ypPopBlock", 1, 0.0);	
        rmSetObjectDefMinDistance(playerPopBlock, 7);
        rmSetObjectDefMaxDistance(playerPopBlock, 10);
	    rmAddObjectDefConstraint(playerPopBlock, avoidAll);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER SEROW:
	    int playerBisonID=rmCreateObjectDef("The Player Bison");
        rmAddObjectDefItem(playerBisonID, "Bison", 7, 6.0);
        rmSetObjectDefCreateHerd(playerBisonID, false);		
        rmSetObjectDefMinDistance(playerBisonID, 15);
	    rmSetObjectDefMaxDistance(playerBisonID, 20);	
	    rmAddObjectDefConstraint(playerBisonID, avoidAll);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
		//rmAddObjectDefToClass(playerNuggetID, rmClassID("resource"));
	    rmSetNuggetDifficulty(1, 1);
	    rmSetObjectDefMinDistance(playerNuggetID, 23.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 28.0);
		rmAddObjectDefConstraint(playerNuggetID, avoidAll);
        rmAddObjectDefConstraint(playerNuggetID, avoidPlayerBerries);		
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		// DEFINE THE START AREA TREE:
	    int StartAreaTreeID=rmCreateObjectDef("The Starting Trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 11, 9.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 30.0);	
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 35.0);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidTrees);
        rmAddObjectDefConstraint(StartAreaTreeID, avoidPlayerBerries);
		rmAddObjectDefConstraint(StartAreaTreeID, treeAvoidPlayerNugget);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
	
        // DEFINE THE VARIABLE FOR THE WATER SPAWN POINT:
		int waterSpawnPointID = 0;	
	
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.475);
/*================================================================================================================================================*/	
// ***************************************** DEFINE THE TCID AND THE STARTING UNITS AND RESOURCES: ********************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // CLEAR OUT CONSTRAINTS FOR GOOD MEASURE:
        rmClearClosestPointConstraints(); 
   
	    for(i=1; <cNumberPlayers)
		
    {
	    // PLACE THE TCID:
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));				
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

        // PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

        // PLACE THE PLAYER CRATE:
		rmPlaceObjectDefAtLoc(playerCrateID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

        // PLACE THE PLAYER BERRIES:
		rmPlaceObjectDefAtLoc(playerBerriesID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

        // PLACE THE PLAYER POP BLOCK:
		rmPlaceObjectDefAtLoc(playerPopBlock, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER SEROW:
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER NUGGET:
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        //rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

        // PLACE THE START AREA TREE:
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	    rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// NOMAD:
		if(ypIsAsian(i) && rmGetNomadStart() == false)
        rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	
		// PLACE THE WATER SPAWN POINTS FOR THE PLAYERS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);
		
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand); 
        //rmAddClosestPointConstraint(flagEdgeConstraint); 
		
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));

   		// CLEAR CLOSEST POINT FOR NEXT ITERATION:
        rmClearClosestPointConstraints();
	}
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.50);
/*================================================================================================================================================*/
// ************************************************** DEFINE AND PLACE THE NATIVE AMERICANS: **************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

    // CREATE THE NATIVES CLASS:
	int classNatives=rmDefineClass("natives");
    
	// CREATE THE NATIVES CONSTRAINTS:
	int nativesConstraint=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	int nativesCloseConstraint=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 10.0);
	int nativesVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff avoids natives", rmClassID("natives"), 5.0);
    int nativesMediumConstraint=rmCreateClassDistanceConstraint("medium vs natives", rmClassID("natives"), 35.0);
	int nativesFarConstraint=rmCreateClassDistanceConstraint("far vs natives", rmClassID("natives"), 65.0);
	
	// CREATE THE IMPORTANT ITEM CLASS:
	int importantItemClass=rmDefineClass("importantItem");
	
	// CREATE THE IMPORTANT ITEM CONSTRAINTS:
	int importantItemConstraint=rmCreateClassDistanceConstraint("stuff vs importantItem", rmClassID("importantItem"), 15.0);
    int importantMediumItemConstraint=rmCreateClassDistanceConstraint("medium vs importantItem", rmClassID("importantItem"), 35.0);
    int importantFarItemConstraint=rmCreateClassDistanceConstraint("far vs importantItem", rmClassID("importantItem"), 65.0);

/*------------------------------------------------------------------------------------------------------------------------------------------------*//*------------------------------------------------------------------------------------------------------------------------------------------------*/

        float NativeVillageLoc = rmRandFloat(0,1);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

        if (subCiv0 == rmGetCivID("Comanche"))
    {  
        int comancheVillageAID = -1;
        int comancheVillageType = rmRandInt(1,5);
        comancheVillageAID = rmCreateGrouping("comanche village A", "native comanche village "+comancheVillageType);
        rmSetGroupingMinDistance(comancheVillageAID, 0.0);
        rmSetGroupingMaxDistance(comancheVillageAID, rmXFractionToMeters(0.0));
        rmAddGroupingToClass(comancheVillageAID, rmClassID("importantItem"));
        rmAddGroupingToClass(comancheVillageAID, rmClassID("natives"));
        rmAddGroupingConstraint(comancheVillageAID, nativesConstraint);
        rmAddGroupingConstraint(comancheVillageAID, importantItemConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		{
			rmPlaceGroupingAtLoc(comancheVillageAID, 0, 0.85, 0.65);
		}
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	

        if (subCiv1 == rmGetCivID("Cheyenne"))
   {   
        int cheyenneVillageAID = -1;
        int cheyenneVillageType = rmRandInt(1,5);
        cheyenneVillageAID = rmCreateGrouping("cheyenne village A", "native cheyenne village "+cheyenneVillageType);
        rmSetGroupingMinDistance(cheyenneVillageAID, 0.0);
        rmSetGroupingMaxDistance(cheyenneVillageAID, rmXFractionToMeters(0.0));
        rmAddGroupingToClass(cheyenneVillageAID, rmClassID("importantItem"));
        rmAddGroupingToClass(cheyenneVillageAID, rmClassID("natives"));
        rmAddGroupingConstraint(cheyenneVillageAID, nativesConstraint);
        rmAddGroupingConstraint(cheyenneVillageAID, importantItemConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
		{
			rmPlaceGroupingAtLoc(cheyenneVillageAID, 0, 0.15, 0.35); 
		}
	}

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
   
	    if(subCiv2 == rmGetCivID("Cheyenne"))
   {   
        int cheyenneVillageID = -1;
        cheyenneVillageType = rmRandInt(1,5);
        cheyenneVillageID = rmCreateGrouping("cheyenne village", "native cheyenne village "+cheyenneVillageType);
        rmSetGroupingMinDistance(cheyenneVillageID, 0.0);
        rmSetGroupingMaxDistance(cheyenneVillageID, rmXFractionToMeters(0.0));
        rmAddGroupingToClass(cheyenneVillageID, rmClassID("importantItem"));
        rmAddGroupingToClass(cheyenneVillageID, rmClassID("natives"));
        rmAddGroupingConstraint(cheyenneVillageID, nativesConstraint);
		rmAddGroupingConstraint(cheyenneVillageID, importantItemConstraint);
		
		rmPlaceGroupingAtLoc(cheyenneVillageID, 0, 0.20, 0.80);
			
   }
   
/*------------------------------------------------------------------------------------------------------------------------------------------------*/   

	    if(subCiv3 == rmGetCivID("Comanche"))
   {   
        int comancheVillageBID = -1;
        comancheVillageType = rmRandInt(1,5);
        comancheVillageBID = rmCreateGrouping("comanche village B", "native comanche village "+comancheVillageType);
        rmSetGroupingMinDistance(comancheVillageBID, 0.0);
        rmSetGroupingMaxDistance(comancheVillageBID, rmXFractionToMeters(0.0));
        rmAddGroupingToClass(comancheVillageBID, rmClassID("importantItem"));
        rmAddGroupingToClass(comancheVillageBID, rmClassID("natives"));
        rmAddGroupingConstraint(comancheVillageBID, nativesConstraint);
	    rmAddGroupingConstraint(comancheVillageBID, importantItemConstraint);
		
		rmPlaceGroupingAtLoc(comancheVillageBID, 0, 0.80, 0.20);
   }
   
/*------------------------------------------------------------------------------------------------------------------------------------------------*/   

	    if(subCiv4 == rmGetCivID("Comanche"))
   {
        int comancheVillageID = -1;
        comancheVillageType = rmRandInt(1,5);
        comancheVillageID = rmCreateGrouping("comanche village", "native comanche village "+comancheVillageType);
        rmSetGroupingMinDistance(comancheVillageID, 0.0);
	    rmSetGroupingMaxDistance(comancheVillageID, rmXFractionToMeters(0.0));
        rmAddGroupingToClass(comancheVillageID, rmClassID("importantItem"));
        rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
        rmAddGroupingConstraint(comancheVillageID, nativesConstraint);
        rmAddGroupingConstraint(comancheVillageID, importantItemConstraint);
		
		rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.35, 0.65);
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	

        if (subCiv5 == rmGetCivID("Cheyenne"))
   {   
        int cheyenneVillageBID = -1;
        cheyenneVillageType = rmRandInt(1,5);
        cheyenneVillageBID = rmCreateGrouping("cheyenne village B", "native cheyenne village "+cheyenneVillageType);
        rmSetGroupingMinDistance(cheyenneVillageBID, 0.0);
        rmSetGroupingMaxDistance(cheyenneVillageBID, rmXFractionToMeters(0.0));
        rmAddGroupingToClass(cheyenneVillageBID, rmClassID("importantItem"));
        rmAddGroupingToClass(cheyenneVillageBID, rmClassID("natives"));
        rmAddGroupingConstraint(cheyenneVillageBID, nativesConstraint);
        rmAddGroupingConstraint(cheyenneVillageBID, importantItemConstraint);

		rmPlaceGroupingAtLoc(cheyenneVillageBID, 0, 0.65, 0.35);
   }

/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.525);
/*================================================================================================================================================*/
// ****************************************************** DEFINE AND PLACE THE FOREST AREAS: **************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // CREATE THE FOREST CLASS:
		int forestClass=rmDefineClass("classForest");
		
		// CREATE THE FOREST CONSTRAINT:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	    int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 45.0);
        int forestCloseConstraint=rmCreateClassDistanceConstraint("close vs. forest", rmClassID("classForest"), 10.0);
        int forestFarConstraint=rmCreateClassDistanceConstraint("far vs. forest", rmClassID("classForest"), 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int forestTreeID = 0;

	    if (cNumberNonGaiaPlayers <=2)
		numTries = 8.50 * cNumberNonGaiaPlayers;
	    else
		numTries = 4.25 * cNumberNonGaiaPlayers;
	    
		failCount=0;
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
	    
		// THE NORTHERN FORESTS:
		for (i=0; <numTries)
{   
		int forestID=rmCreateArea("forestID"+i);
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(475), rmAreaTilesToFraction(475));
		rmSetAreaForestType(forestID, "great plains forest");
		
		rmSetAreaForestDensity(forestID, 1.0);
		rmSetAreaForestClumpiness(forestID, 0.0);		
		rmSetAreaForestUnderbrush(forestID, 0.0);
		
		rmSetAreaMinBlobs(forestID, 1);
		rmSetAreaMaxBlobs(forestID, 1);						
		rmSetAreaMinBlobDistance(forestID, 1.0);
		rmSetAreaMaxBlobDistance(forestID, 1.0);
		
		rmSetAreaCoherence(forestID, 1.0);
		rmSetAreaSmoothDistance(forestID, 5);
		rmAddAreaToClass(forestID, rmClassID("classForest"));
		
		rmAddAreaConstraint(forestID, forestFarConstraint);
		rmAddAreaConstraint(forestID, nativesConstraint);
		rmAddAreaConstraint(forestID, playerConstraint);
		rmAddAreaConstraint(forestID, playerEdgeConstraint);
		rmAddAreaConstraint(forestID, avoidTradeRoute);
		rmAddAreaConstraint(forestID, avoidSocket);
		rmAddAreaConstraint(forestID, lakeConstraint);
		rmAddAreaConstraint(forestID, Northward);
		
		if(rmBuildArea(forestID)==false)
	{
		// Stop trying once we fail 10 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0; 
}

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN FORESTS:
		for (i=0; <numTries)
{   
		int forest2ID=rmCreateArea("forestID 2"+i);
		rmSetAreaWarnFailure(forest2ID, false);
		rmSetAreaSize(forest2ID, rmAreaTilesToFraction(475), rmAreaTilesToFraction(475));
		
		rmSetAreaForestType(forest2ID, "great plains forest");
		
		rmSetAreaForestDensity(forest2ID, 1.0);
		rmSetAreaForestClumpiness(forest2ID, 0.0);		
		rmSetAreaForestUnderbrush(forest2ID, 0.0);
		
		rmSetAreaMinBlobs(forest2ID, 1);
		rmSetAreaMaxBlobs(forest2ID, 1);						
		rmSetAreaMinBlobDistance(forest2ID, 1.0);
		rmSetAreaMaxBlobDistance(forest2ID, 1.0);
		
		rmSetAreaCoherence(forest2ID, 1.0);
		rmSetAreaSmoothDistance(forest2ID, 5);
		rmAddAreaToClass(forest2ID, rmClassID("classForest"));
		
		rmAddAreaConstraint(forest2ID, forestFarConstraint);
		rmAddAreaConstraint(forest2ID, playerConstraint);
		rmAddAreaConstraint(forest2ID, playerEdgeConstraint);
		rmAddAreaConstraint(forest2ID, avoidTradeRoute);
		rmAddAreaConstraint(forest2ID, nativesConstraint);
		rmAddAreaConstraint(forest2ID, avoidSocket);
		rmAddAreaConstraint(forest2ID, lakeConstraint);
		rmAddAreaConstraint(forest2ID, Southward);
		
		if(rmBuildArea(forest2ID)==false)
	{
		// Stop trying once we fail 10 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
		else
		failCount=0; 
}

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE SILVER MINES: ***************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

    int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid coin", "gold", 15.0);
	int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 10.0);
	int avoidVeryCloseCoin=rmCreateTypeDistanceConstraint("very close avoid coin", "gold", 5.0);
	int avoidFarCoin=rmCreateTypeDistanceConstraint("far avoid coin", "gold", 65.0);
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    int silverType = -1;
		if (cNumberNonGaiaPlayers <=2)
	    int silverCount = 12;
		else
		silverCount = 12;
	    rmEchoInfo("silver count = "+silverCount);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

	    for(i=0; < silverCount)
	{
	    int silverID = rmCreateObjectDef("silver "+i);
	    rmAddObjectDefItem(silverID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));

		rmAddObjectDefConstraint(silverID, avoidFarCoin);
        rmAddObjectDefConstraint(silverID, playerConstraint);
        rmAddObjectDefConstraint(silverID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silverID, forestCloseConstraint);
	    rmAddObjectDefConstraint(silverID, nativesCloseConstraint);
        rmAddObjectDefConstraint(silverID, lakeConstraint);
	    rmAddObjectDefConstraint(silverID, avoidTradeRoute);
		rmAddObjectDefConstraint(silverID, avoidSocket);
	    rmAddObjectDefConstraint(silverID, Northward);
	    
		rmPlaceObjectDefAtLoc(silverID, 0, 0.50, 0.50);
   }

/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    for(i=0; < silverCount)
	{
	    int silver2ID = rmCreateObjectDef("silver 2 "+i);
	    rmAddObjectDefItem(silver2ID, "mine", 1, 0.0);
        rmSetObjectDefMinDistance(silver2ID, 0.0);
        rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(silver2ID, avoidFarCoin);
        rmAddObjectDefConstraint(silver2ID, playerConstraint);
        rmAddObjectDefConstraint(silver2ID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silver2ID, forestCloseConstraint);
	    rmAddObjectDefConstraint(silver2ID, nativesCloseConstraint);
        rmAddObjectDefConstraint(silver2ID, lakeConstraint);
	    rmAddObjectDefConstraint(silver2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(silver2ID, avoidSocket);
	    rmAddObjectDefConstraint(silver2ID, Southward);
	    
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.50, 0.50);
   }

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.575);
/*================================================================================================================================================*/
// ********************************************** DEFINE AND PLACE THE NUGGETS: -(TREASURES)- *************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
  
	    int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 10.0);
		int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close avoid nugget", "AbstractNugget", 5.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium avoid nugget", "AbstractNugget", 35.0);
	    int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN NUGGETS: ( -TREASURES- ) 
		int nuggetID= rmCreateObjectDef("The Northern Nugget"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID, avoidCloseCoin);
		rmAddObjectDefConstraint(nuggetID, forestCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, nativesCloseConstraint);
		rmAddObjectDefConstraint(nuggetID, playerConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
		rmAddObjectDefConstraint(nuggetID, avoidSocket);
		rmAddObjectDefConstraint(nuggetID, lakeConstraint);
		rmAddObjectDefConstraint(nuggetID, Northward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	
        
		// THE SOUTHERN NUGGETS: ( -TREASURES- ) 
		int nugget2ID= rmCreateObjectDef("The Southern Nugget"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 4);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(nugget2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, nativesCloseConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerConstraint);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(nugget2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(nugget2ID, avoidSocket);
		rmAddObjectDefConstraint(nugget2ID, lakeConstraint);
		rmAddObjectDefConstraint(nugget2ID, Southward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================================================*/
// ******************************************************* DEFINE AND PLACE THE BERRIES: ******************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
  
	    int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid berries", "AbstractFruit", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid berries", "AbstractFruit", 10.0);
		int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid berries", "AbstractFruit", 5.0);
		int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium avoid berries", "AbstractFruit", 30.0);
	    int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid berries", "AbstractFruit", 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN BERRYBUSH:
		int fruitsID= rmCreateObjectDef("The Northern Berries"); 
	    rmAddObjectDefItem(fruitsID, "berrybush", rmRandInt(5,9), 6.0); 
		rmSetObjectDefCreateHerd(fruitsID, false);
	    rmSetObjectDefMinDistance(fruitsID, 0.0);
	    rmSetObjectDefMaxDistance(fruitsID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(fruitsID, avoidFarFruits);
		rmAddObjectDefConstraint(fruitsID, avoidCloseNugget);
		rmAddObjectDefConstraint(fruitsID, avoidCloseCoin);
		rmAddObjectDefConstraint(fruitsID, forestCloseConstraint);
		rmAddObjectDefConstraint(fruitsID, nativesCloseConstraint);
		rmAddObjectDefConstraint(fruitsID, playerConstraint);
		rmAddObjectDefConstraint(fruitsID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruitsID, avoidTradeRoute);
		rmAddObjectDefConstraint(fruitsID, avoidSocket);
		rmAddObjectDefConstraint(fruitsID, lakeConstraint);
		rmAddObjectDefConstraint(fruitsID, Northward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(fruitsID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(fruitsID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		// THE SOUTHERN BERRYBUSH:
		int fruits2ID= rmCreateObjectDef("The Southern Berries"); 
	    rmAddObjectDefItem(fruits2ID, "berrybush", rmRandInt(5,9), 6.0); 
		rmSetObjectDefCreateHerd(fruits2ID, false);
	    rmSetObjectDefMinDistance(fruits2ID, 0.0);
	    rmSetObjectDefMaxDistance(fruits2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(fruits2ID, avoidFarFruits);
		rmAddObjectDefConstraint(fruits2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(fruits2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(fruits2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(fruits2ID, nativesCloseConstraint);
		rmAddObjectDefConstraint(fruits2ID, playerConstraint);
		rmAddObjectDefConstraint(fruits2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(fruits2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(fruits2ID, avoidSocket);
		rmAddObjectDefConstraint(fruits2ID, lakeConstraint);
		rmAddObjectDefConstraint(fruits2ID, Southward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(fruits2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}	

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================================================*/
// **************************************************** DEFINE AND PLACE THE BISONS HERDS: ****************************************************** //
/*================================================================================================================================================*/        
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		int avoidHuntable=rmCreateTypeDistanceConstraint("stuff avoid bison", "bison", 15.0);
		int avoidCloseHuntable=rmCreateTypeDistanceConstraint("close avoid bison", "bison", 10.0);
		int avoidVeryCloseHuntable=rmCreateTypeDistanceConstraint("very close avoid bison", "bison", 5.0);
		int avoidMediumHuntable=rmCreateTypeDistanceConstraint("medium avoid bison", "bison", 30.0);
	    int avoidFarHuntable=rmCreateTypeDistanceConstraint("far avoid bison", "bison", 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN BISONS HERDS:
		int huntableID= rmCreateObjectDef("The Northern Bisons Herds"); 
	    rmAddObjectDefItem(huntableID, "bison", rmRandInt(7,9), 7.0); 
		rmSetObjectDefCreateHerd(huntableID, false);
	    rmSetObjectDefMinDistance(huntableID, 0.0);
	    rmSetObjectDefMaxDistance(huntableID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(huntableID, avoidFarHuntable);
		rmAddObjectDefConstraint(huntableID, avoidCloseFruits);
		rmAddObjectDefConstraint(huntableID, avoidCloseNugget);
		rmAddObjectDefConstraint(huntableID, avoidCloseCoin);
		rmAddObjectDefConstraint(huntableID, forestCloseConstraint);
		rmAddObjectDefConstraint(huntableID, nativesCloseConstraint);
		rmAddObjectDefConstraint(huntableID, playerConstraint);
		rmAddObjectDefConstraint(huntableID, playerEdgeConstraint);
		rmAddObjectDefConstraint(huntableID, avoidTradeRoute);
		rmAddObjectDefConstraint(huntableID, avoidSocket);
		rmAddObjectDefConstraint(huntableID, lakeConstraint);
		rmAddObjectDefConstraint(huntableID, Northward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(huntableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(huntableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// THE SOUTHERN BISONS HERDS:
		int huntable2ID= rmCreateObjectDef("The Southern Bisons Herds"); 
	    rmAddObjectDefItem(huntable2ID, "bison", rmRandInt(7,9), 7.0); 
		rmSetObjectDefCreateHerd(huntable2ID, false);
	    rmSetObjectDefMinDistance(huntable2ID, 0.0);
	    rmSetObjectDefMaxDistance(huntable2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(huntable2ID, avoidFarHuntable);
		rmAddObjectDefConstraint(huntable2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(huntable2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(huntable2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(huntable2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(huntable2ID, nativesCloseConstraint);
		rmAddObjectDefConstraint(huntable2ID, playerConstraint);
		rmAddObjectDefConstraint(huntable2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(huntable2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(huntable2ID, avoidSocket);
		rmAddObjectDefConstraint(huntable2ID, lakeConstraint);
		rmAddObjectDefConstraint(huntable2ID, Southward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(huntable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(huntable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE COWS HERDS: ******************************************************* //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		int avoidHerdable=rmCreateTypeDistanceConstraint("stuff avoid cow", "cow", 15.0);
		int avoidCloseHerdable=rmCreateTypeDistanceConstraint("close avoid cow", "cow", 10.0);
		int avoidVeryCloseHerdable=rmCreateTypeDistanceConstraint("very close avoid cow", "cow", 5.0);
		int avoidMediumHerdable=rmCreateTypeDistanceConstraint("medium avoid cow", "cow", 30.0);
	    int avoidFarHerdable=rmCreateTypeDistanceConstraint("far avoid cow", "cow", 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN COW HERDS:
		int herdableID= rmCreateObjectDef("The Northern Cow Herds"); 
	    rmAddObjectDefItem(herdableID, "cow", rmRandInt(5,7), 6.0); 
		rmSetObjectDefCreateHerd(herdableID, false);
	    rmSetObjectDefMinDistance(herdableID, 0.0);
	    rmSetObjectDefMaxDistance(herdableID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(herdableID, avoidFarHerdable);
		rmAddObjectDefConstraint(herdableID, avoidMediumHuntable);
		rmAddObjectDefConstraint(herdableID, avoidCloseFruits);
		rmAddObjectDefConstraint(herdableID, avoidCloseNugget);
		rmAddObjectDefConstraint(herdableID, avoidCloseCoin);
		rmAddObjectDefConstraint(herdableID, forestCloseConstraint);
		rmAddObjectDefConstraint(herdableID, nativesCloseConstraint);
		rmAddObjectDefConstraint(herdableID, playerConstraint);
		rmAddObjectDefConstraint(herdableID, playerEdgeConstraint);
		rmAddObjectDefConstraint(herdableID, avoidTradeRoute);
		rmAddObjectDefConstraint(herdableID, avoidSocket);
		rmAddObjectDefConstraint(herdableID, lakeConstraint);
		rmAddObjectDefConstraint(herdableID, Northward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(herdableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(herdableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}	

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
	
		// THE SOUTHERN COW HERDS:
		int herdable2ID= rmCreateObjectDef("The Southern Cow Herds"); 
	    rmAddObjectDefItem(herdable2ID, "cow", rmRandInt(5,7), 6.0); 
		rmSetObjectDefCreateHerd(herdable2ID, false);
	    rmSetObjectDefMinDistance(herdable2ID, 0.0);
	    rmSetObjectDefMaxDistance(herdable2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(herdable2ID, avoidFarHerdable);
		rmAddObjectDefConstraint(herdable2ID, avoidMediumHuntable);
		rmAddObjectDefConstraint(herdable2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(herdable2ID, avoidCloseNugget);
		rmAddObjectDefConstraint(herdable2ID, avoidCloseCoin);
		rmAddObjectDefConstraint(herdable2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(herdable2ID, nativesCloseConstraint);
		rmAddObjectDefConstraint(herdable2ID, playerConstraint);
		rmAddObjectDefConstraint(herdable2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(herdable2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(herdable2ID, avoidSocket);
		rmAddObjectDefConstraint(herdable2ID, lakeConstraint);
		rmAddObjectDefConstraint(herdable2ID, Southward);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(herdable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(herdable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
	}	

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE GEYSERS: ********************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // CREATE THE NATIVES CLASS:
	    int classGeysers=rmDefineClass("geysers");
    
	    // CREATE THE NATIVES CONSTRAINTS:
	    int geysersConstraint=rmCreateClassDistanceConstraint("stuff avoids geysers", rmClassID("geysers"), 15.0);
		int geysersVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff avoids geysers", rmClassID("geysers"), 5.0);
		int geysersFarConstraint=rmCreateClassDistanceConstraint("far stuff avoids geysers", rmClassID("geysers"), 65.0);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// THE NORTHERN GEYSERS:
		int geyserID=rmCreateGrouping("Geysers 1", "prop_geyser");
	    rmSetGroupingMinDistance(geyserID, 0.0);
	    rmSetGroupingMaxDistance(geyserID, rmXFractionToMeters(0.5));
		rmAddGroupingToClass(geyserID, rmClassID("geysers"));
        
		rmAddGroupingConstraint(geyserID, geysersFarConstraint);
		rmAddGroupingConstraint(geyserID, avoidHerdable);
	    rmAddGroupingConstraint(geyserID, avoidHuntable);
	    rmAddGroupingConstraint(geyserID, avoidCloseFruits);
	    rmAddGroupingConstraint(geyserID, avoidAll);
	    rmAddGroupingConstraint(geyserID, avoidCloseNugget);
	    rmAddGroupingConstraint(geyserID, avoidTradeRoute);
	    rmAddGroupingConstraint(geyserID, avoidSocket);
	    rmAddGroupingConstraint(geyserID, avoidCloseCoin);
	    rmAddGroupingConstraint(geyserID, playerConstraint);
		rmAddGroupingConstraint(geyserID, playerEdgeConstraint);
	    rmAddGroupingConstraint(geyserID, lakeConstraint);
		rmAddGroupingConstraint(geyserID, forestCloseConstraint);
		rmAddGroupingConstraint(geyserID, nativesConstraint);
		//rmAddGroupingConstraint(geyserID, circleConstraint);
		rmAddGroupingConstraint(geyserID, Northward);
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceGroupingAtLoc(geyserID, 0, 0.5, 0.5, 2.5);
		else
		rmPlaceGroupingAtLoc(geyserID, 0, 0.5, 0.5, 1.25);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN GEYSERS:
		int geyser2ID=rmCreateGrouping("Geysers 2", "prop_geyser");
	    rmSetGroupingMinDistance(geyser2ID, 0.0);
	    rmSetGroupingMaxDistance(geyser2ID, rmXFractionToMeters(0.5));
		rmAddGroupingToClass(geyser2ID, rmClassID("geysers"));
        
		rmAddGroupingConstraint(geyser2ID, geysersFarConstraint);
		rmAddGroupingConstraint(geyser2ID, avoidHerdable);
	    rmAddGroupingConstraint(geyser2ID, avoidHuntable);
	    rmAddGroupingConstraint(geyser2ID, avoidCloseFruits);
	    rmAddGroupingConstraint(geyser2ID, avoidAll);
	    rmAddGroupingConstraint(geyser2ID, avoidCloseNugget);
	    rmAddGroupingConstraint(geyser2ID, avoidTradeRoute);
	    rmAddGroupingConstraint(geyser2ID, avoidSocket);
	    rmAddGroupingConstraint(geyser2ID, avoidCloseCoin);
	    rmAddGroupingConstraint(geyser2ID, playerConstraint);
		rmAddGroupingConstraint(geyser2ID, playerEdgeConstraint);
	    rmAddGroupingConstraint(geyser2ID, lakeConstraint);
		rmAddGroupingConstraint(geyser2ID, forestCloseConstraint);
		rmAddGroupingConstraint(geyser2ID, nativesConstraint);
		//rmAddGroupingConstraint(geyser2ID, circleConstraint);
		rmAddGroupingConstraint(geyser2ID, Southward);
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceGroupingAtLoc(geyser2ID, 0, 0.5, 0.5, 5);
        else
        rmPlaceGroupingAtLoc(geyser2ID, 0, 0.5, 0.5, 5);

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================================================*/
// ********************************************** DEFINE AND PLACE SOME PERCHING VULTURES: ****************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        int avoidVultures=rmCreateTypeDistanceConstraint("stuff avoid vultures", "PropVulturePerching", 15.0);
		int avoidVeryCloseVultures=rmCreateTypeDistanceConstraint("very close stuff avoid vultures", "PropVulturePerching", 5.0);
		int avoidFarVultures=rmCreateTypeDistanceConstraint("far stuff avoid vultures", "PropVulturePerching", 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN PERCHING VULTURES:
		int vultureID=rmCreateObjectDef("The Northern Perching Vultures");
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(vultureID, avoidFarVultures);
	    rmAddObjectDefConstraint(vultureID, geysersConstraint);
	    rmAddObjectDefConstraint(vultureID, avoidHerdable);
		rmAddObjectDefConstraint(vultureID, avoidHuntable);
	    rmAddObjectDefConstraint(vultureID, avoidAll);
	    rmAddObjectDefConstraint(vultureID, avoidCloseFruits);
	    rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	    rmAddObjectDefConstraint(vultureID, avoidSocket);
	    rmAddObjectDefConstraint(vultureID, avoidCloseNugget);
	    rmAddObjectDefConstraint(vultureID, avoidCloseCoin);
	    rmAddObjectDefConstraint(vultureID, playerConstraint);
		rmAddObjectDefConstraint(vultureID, playerEdgeConstraint);
		rmAddObjectDefConstraint(vultureID, lakeConstraint);
		rmAddObjectDefConstraint(vultureID, forestCloseConstraint);
		rmAddObjectDefConstraint(vultureID, nativesConstraint);
		rmAddObjectDefConstraint(vultureID, Northward);
	    
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 5);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN PERCHING VULTURES:
		int vulture2ID=rmCreateObjectDef("The Southern Perching Vultures");
	    rmAddObjectDefItem(vulture2ID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vulture2ID, 0.0);
	    rmSetObjectDefMaxDistance(vulture2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(vulture2ID, avoidFarVultures);
	    rmAddObjectDefConstraint(vulture2ID, geysersConstraint);
	    rmAddObjectDefConstraint(vulture2ID, avoidHerdable);
		rmAddObjectDefConstraint(vulture2ID, avoidHuntable);
	    rmAddObjectDefConstraint(vulture2ID, avoidAll);
	    rmAddObjectDefConstraint(vulture2ID, avoidCloseFruits);
	    rmAddObjectDefConstraint(vulture2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(vulture2ID, avoidSocket);
	    rmAddObjectDefConstraint(vulture2ID, avoidCloseNugget);
	    rmAddObjectDefConstraint(vulture2ID, avoidCloseCoin);
	    rmAddObjectDefConstraint(vulture2ID, playerConstraint);
		rmAddObjectDefConstraint(vulture2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(vulture2ID, lakeConstraint);
		rmAddObjectDefConstraint(vulture2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(vulture2ID, nativesConstraint);
		rmAddObjectDefConstraint(vulture2ID, Southward);
	    
		rmPlaceObjectDefAtLoc(vulture2ID, 0, 0.5, 0.5, 5);
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================================================*/
// ********************************** 50% CHANCE OF BUFFALO CARCASSES - EITHER ONE OR TWO IF THEY'RE THERE: ************************************* //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    //int avoidCarcass=rmCreateTypeDistanceConstraint("stuff avoid bison carcass", "gp_carcass_bison", 15.0);
		
		// CREATE THE NATIVES CLASS:
	    int classCarcass=rmDefineClass("carcass");
    
	    // CREATE THE NATIVES CONSTRAINTS:
	    int carcassConstraint=rmCreateClassDistanceConstraint("stuff avoids carcass bison", rmClassID("carcass"), 15.0);
		int carcassVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff avoids carcass bison", rmClassID("carcass"), 5.0);
		int carcassFarConstraint=rmCreateClassDistanceConstraint("far stuff avoids carcass bison", rmClassID("carcass"), 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN BISON CARCASS:
		int areThereBuffalo=rmRandInt(1, 2);
	    int howManyBuffalo=rmRandInt(3, 5);
	    if ( areThereBuffalo == 1 )
	{
		int bisonCarcass=rmCreateGrouping("The Northern Bison Carcass", "gp_carcass_bison");
		rmAddGroupingToClass(bisonCarcass, rmClassID("carcass"));
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		
		rmAddGroupingConstraint(bisonCarcass, carcassFarConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidVultures);
		rmAddGroupingConstraint(bisonCarcass, geysersConstraint);
		rmAddGroupingConstraint(bisonCarcass, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass, playerEdgeConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseFruits);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseNugget);
		rmAddGroupingConstraint(bisonCarcass, lakeConstraint);
		rmAddGroupingConstraint(bisonCarcass, nativesConstraint);
		rmAddGroupingConstraint(bisonCarcass, forestCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidCloseCoin);
		rmAddGroupingConstraint(bisonCarcass, avoidHerdable);
		rmAddGroupingConstraint(bisonCarcass, avoidHuntable);
		rmAddGroupingConstraint(bisonCarcass, Northward);
		
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BISON CARCASS:
		areThereBuffalo=rmRandInt(1, 2);
	    howManyBuffalo=rmRandInt(3, 5);
	    if ( areThereBuffalo == 1 )
	{
		int bisonCarcass2=rmCreateGrouping("The Southern Bison Carcass", "gp_carcass_bison");
		rmAddGroupingToClass(bisonCarcass2, rmClassID("carcass"));
		rmSetGroupingMinDistance(bisonCarcass2, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass2, rmXFractionToMeters(0.5));
		
		rmAddGroupingConstraint(bisonCarcass2, carcassFarConstraint);
		rmAddGroupingConstraint(bisonCarcass2, avoidVultures);
		rmAddGroupingConstraint(bisonCarcass2, geysersConstraint);
		rmAddGroupingConstraint(bisonCarcass2, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass2, playerEdgeConstraint);
		rmAddGroupingConstraint(bisonCarcass2, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass2, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass2, avoidCloseFruits);
		rmAddGroupingConstraint(bisonCarcass2, avoidAll);
		rmAddGroupingConstraint(bisonCarcass2, avoidCloseNugget);
		rmAddGroupingConstraint(bisonCarcass2, lakeConstraint);
		rmAddGroupingConstraint(bisonCarcass2, nativesConstraint);
		rmAddGroupingConstraint(bisonCarcass2, forestCloseConstraint);
		rmAddGroupingConstraint(bisonCarcass2, avoidCloseCoin);
		rmAddGroupingConstraint(bisonCarcass2, avoidHerdable);
		rmAddGroupingConstraint(bisonCarcass2, avoidHuntable);
		rmAddGroupingConstraint(bisonCarcass2, Southward);
		
		rmPlaceGroupingAtLoc(bisonCarcass2, 0, 0.5, 0.5, howManyBuffalo);
	}
	
/*================================================================================================================================================*/
// **************************************************** DEFINE AND PLACE SOME RANDOM TREES: ***************************************************** //
/*================================================================================================================================================*/

        int avoidTree=rmCreateTypeDistanceConstraint("stuff avoid tree", "tree", 15.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("close avoid tree", "tree", 10.0);
		int avoidVeryCloseTree=rmCreateTypeDistanceConstraint("very close avoid tree", "tree", 5.0);
		int avoidMediumTree=rmCreateTypeDistanceConstraint("medium avoid tree", "tree", 30.0);
	    int avoidFarTree=rmCreateTypeDistanceConstraint("far avoid tree", "tree", 65.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

        // THE NORTHERN RANDOM TREES:
		int randomTreeID=rmCreateObjectDef("The Northern Random Trees");
	    rmAddObjectDefItem(randomTreeID, "TreeGreatPlains", 3, 6.0);
	    rmSetObjectDefMinDistance(randomTreeID, 0.0);
	    rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	
	    rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseTree);
	    rmAddObjectDefConstraint(randomTreeID, carcassVeryCloseConstraint);
	    rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseVultures);
	    rmAddObjectDefConstraint(randomTreeID, geysersVeryCloseConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, playerConstraint);
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidSocket);
		rmAddObjectDefConstraint(randomTreeID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, Northward);
		rmAddObjectDefConstraint(randomTreeID, nativesVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidWater5);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseFruits);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseNugget);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseHerdable);
		rmAddObjectDefConstraint(randomTreeID, avoidVeryCloseHuntable);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*40.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*20.0);
	}	
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN RANDOM TREES:
		int randomTree2ID=rmCreateObjectDef("The Southern Random Trees");
	    rmAddObjectDefItem(randomTree2ID, "TreeGreatPlains", 3, 6.0);
	    rmSetObjectDefMinDistance(randomTree2ID, 0.0);
	    rmSetObjectDefMaxDistance(randomTree2ID, rmXFractionToMeters(0.5));
	
	    rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseTree);
	    rmAddObjectDefConstraint(randomTree2ID, carcassVeryCloseConstraint);
	    rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseVultures);
	    rmAddObjectDefConstraint(randomTree2ID, geysersVeryCloseConstraint); 
	    rmAddObjectDefConstraint(randomTree2ID, playerConstraint);
		rmAddObjectDefConstraint(randomTree2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(randomTree2ID, avoidSocket);
		rmAddObjectDefConstraint(randomTree2ID, forestCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, Southward);
		rmAddObjectDefConstraint(randomTree2ID, nativesVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTree2ID, avoidAll);
		rmAddObjectDefConstraint(randomTree2ID, avoidWater5);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseFruits);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseNugget);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseCoin);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseHerdable);
		rmAddObjectDefConstraint(randomTree2ID, avoidVeryCloseHuntable);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*40.0);
	}
        else
	{
        rmPlaceObjectDefAtLoc(randomTree2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*20.0);
	}		
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================================================*/
// ********************************************************* CHECK FOR KOTH GAME MODE: ********************************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
  
        // CREATE THE KOTH CONSTRAINT:
		int avoidKOTH = rmCreateTypeDistanceConstraint("stuff vs. KOTH", "ypKingsHill", 8.0); 

/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        if(rmGetIsKOTH()) 
	{
        
		ypKingsHillLandfill(0.50, 0.50, .005, 3.5, "great plains drygrass", avoidAll);
		ypKingsHillPlacer(0.50, 0.50, 0.01, avoidWater15);
		
    }
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================================================*/
// ************************************** PLACE RANDOM FISH EVERYWHERE, BUT RESTRAINED TO AVOID WHALES: ***************************************** //
/*================================================================================================================================================*/
// NONE FOR NOW:
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    // CREATE THE FISH CONSTRAINTS:
	    int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "AbstractFish", 15.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);			
		int fishVsWhaleID=rmCreateTypeDistanceConstraint("fish v whale", "AbstractWhale", 20.0); 
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// THE FISH MAHI:
		int fishID=rmCreateObjectDef("The Fish Bass");
	    rmAddObjectDefItem(fishID, "FishBass", 3, 9.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(fishID, fishVsFishID);
	    rmAddObjectDefConstraint(fishID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fishID, fishLand);
		
		if (cNumberNonGaiaPlayers<=2) 
	    rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 40*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);	
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================================================*/
}
/*================================================================================================================================================*/
// ******************************************************** THIS IS THE END OF THE MAP: ********************************************************* //
/*================================================================================================================================================*/
